(* This file is automatically generated from the OCaml source file
<repository_root>/ml_sources/transaction_commit/two_phase_code.ml *)

From aneris.aneris_lang Require Import ast.
From aneris.aneris_lang.lib Require Import set_code.
From aneris.aneris_lang.lib Require Import map_code.
From aneris.aneris_lang.lib Require Import network_util_code.
From aneris.aneris_lang.lib Require Import coin_flip_code.
From aneris.aneris_lang.lib Require Import nodup_code.

Definition resource_manager : val :=
  λ: "rm" "tm",
  let: "skt" := NewSocket #PF_INET #SOCK_DGRAM #IPPROTO_UDP in
  SocketBind "skt" "rm";;
  let: "msg" := unSOME (ReceiveFrom "skt") in
  let: "value" := Fst "msg" in
  (if: "value" = #"ABORT"
   then  SendTo "skt" #"ABORTED" "tm"
   else
     let: "local_abort" := coin_flip #() in
     (if: "local_abort"
      then  SendTo "skt" #"ABORTED" "tm"
      else
        SendTo "skt" #"PREPARED" "tm";;
        let: "msg" := wait_receivefrom "skt"
                      (λ: "m",
                       ((Fst "m") = #"COMMIT") || ((Fst "m") = #"ABORT")) in
        let: "decision" := Fst "msg" in
        (if: "decision" = #"COMMIT"
         then  SendTo "skt" #"COMMITTED" "tm"
         else  SendTo "skt" #"ABORTED" "tm"))).

Definition recv_responses : val :=
  λ: "recv" "skt" "rms",
  letrec: "loop" "prepared" :=
    (set_equal "prepared" "rms") || (let: "msg" := ("recv" "skt") in
                                     (((Fst "msg") = #"PREPARED") && 
                                      ("loop" (set_add (Snd "msg") "prepared")))) in
    "loop" (set_empty #()).

Definition transaction_manager : val :=
  λ: "tm" "rms",
  let: "skt" := NewSocket #PF_INET #SOCK_DGRAM #IPPROTO_UDP in
  SocketBind "skt" "tm";;
  let: "recv" := nodup_init #() in
  sendto_all_set "skt" "rms" #"PREPARE";;
  let: "all_prepared" := recv_responses "recv" "skt" "rms" in
  (if: "all_prepared"
   then
     sendto_all_set "skt" "rms" #"COMMIT";;
     let: "resps" := receivefrom_nodup_set "skt" "recv" "rms" in
     map_iter (λ: "_rm" "m", assert: ("m" = #"COMMITTED")) "resps";;
     #"COMMITTED"
   else  sendto_all_set "skt" "rms" #"ABORT";;
         #"ABORTED").
